&ANALYZE-SUSPEND _VERSION-NUMBER UIB_v9r12
&ANALYZE-RESUME
&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _DEFINITIONS Procedure 
/*------------------------------------------------------------------------
  File        : rtb_rpt_product.p
  Description : Products report library
  ----------------------------------------------------------------------*/

{rtb/i/rtb_rptinit.i}

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


&ANALYZE-SUSPEND _UIB-PREPROCESSOR-BLOCK 

/* ********************  Preprocessor Definitions  ******************** */

&Scoped-define PROCEDURE-TYPE Procedure
&Scoped-define DB-AWARE no



/* _UIB-PREPROCESSOR-BLOCK-END */
&ANALYZE-RESUME



/* *********************** Procedure Settings ************************ */

&ANALYZE-SUSPEND _PROCEDURE-SETTINGS
/* Settings for THIS-PROCEDURE
   Type: Procedure
   Allow: 
   Frames: 0
   Add Fields to: Neither
   Other Settings: CODE-ONLY COMPILE
 */
&ANALYZE-RESUME _END-PROCEDURE-SETTINGS

/* *************************  Create Window  ************************** */

&ANALYZE-SUSPEND _CREATE-WINDOW
/* DESIGN Window definition (used by the UIB) 
  CREATE WINDOW Procedure ASSIGN
         HEIGHT             = 21.48
         WIDTH              = 60.
/* END WINDOW DEFINITION */
                                                                        */
&ANALYZE-RESUME

 


&ANALYZE-SUSPEND _UIB-CODE-BLOCK _CUSTOM _MAIN-BLOCK Procedure 


/* ***************************  Main Block  *************************** */

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME


/* **********************  Internal Procedures  *********************** */

&IF DEFINED(EXCLUDE-rptRtbProduct) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbProduct Procedure 
PROCEDURE rptRtbProduct :
/*------------------------------------------------------------------------------
  Purpose:     Product report wrapper
  Parameters:  INPUT Pproduct          - Product
               INPUT PshowWsUsage      - TRUE to show workspace usage
               INPUT PshowObjects      - TRUE to show objects
               INPUT PshowObjDetails   - TRUE to show object details
               INPUT TABLE-HANDLE PhTT - Filespecs temp-table
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pproduct         AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PshowWsUsage     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjects     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjDetails  AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_product_report (INPUT Pproduct,
                          INPUT PshowWsUsage,
                          INPUT PshowObjects,
                          INPUT PshowObjDetails).

  OUTPUT STREAM Sout CLOSE.  

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbProductModule) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbProductModule Procedure 
PROCEDURE rptRtbProductModule :
/*------------------------------------------------------------------------------
  Purpose:     Product module report wrapper
  Parameters:  INPUT Ppmod             - Product module
               INPUT PshowWsUsage      - TRUE to show workspace usage
               INPUT PshowObjects      - TRUE to show objects
               INPUT PshowObjDetails   - TRUE to show object details
               INPUT TABLE-HANDLE PhTT - Filespecs temp-table
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Ppmod            AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PshowWsUsage     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjects     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjDetails  AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_product_module_report (INPUT Ppmod,
                                 INPUT PshowWsUsage,
                                 INPUT PshowObjects,
                                 INPUT PshowObjDetails).

  OUTPUT STREAM Sout CLOSE.  

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rptRtbVersionsInProductModule) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rptRtbVersionsInProductModule Procedure 
PROCEDURE rptRtbVersionsInProductModule :
/*------------------------------------------------------------------------------
  Purpose:     Versions in Product Module Report wrapper
  Parameters:  INPUT Ppmod         - Product module for object
                     Pobj-type     - Object-type for object
                     Pobject       - Object name
                     PbegVersion   - Starting version
                     PendVersion   - Ending version
                     PmaxVersions  - Maximum number of versions to show
                     PshowOrphans  - TRUE to show orphans
                     PshowObjDesc  - TRUE to show object descriptions
                     PshowVerNotes - TRUE to show version notes
                     TABLE-HANDLE PhTT - Filespecs temp-table
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Ppmod            AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pobj-type        AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pobject          AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PbegVersion      AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PendVersion      AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PmaxVersions     AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PshowOrphans     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjDesc     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowVerNotes    AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER TABLE-HANDLE PhTT.

  RUN rtb_report_initialize (INPUT TABLE-HANDLE PhTT).

  RUN rtb_versions_in_product_module_report (INPUT Ppmod,
                                             INPUT Pobj-type,
                                             INPUT Pobject,
                                             INPUT PbegVersion,
                                             INPUT PendVersion,
                                             INPUT PmaxVersions,
                                             INPUT PshowOrphans,
                                             INPUT PshowObjDesc,
                                             INPUT PshowVerNotes).

  OUTPUT STREAM Sout CLOSE.  

  RETURN RETURN-VALUE.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_print_pmod) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_print_pmod Procedure 
PROCEDURE rtb_print_pmod PRIVATE :
/*------------------------------------------------------------------------------
  Purpose:     Print product module detail
  Parameters:  INPUT Ppmod           - Product module
                     PshowUsage      - TRUE to show pmod usage by workspace
                     PshowObjects    - TRUE to show objects
                     PshowObjDetails - TRUE to show object details
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Ppmod            AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PshowWsUsage     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjects     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjDetails  AS LOGICAL     NO-UNDO.
  
  DEFINE VARIABLE Mdescription AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mline        AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MtextLines   AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi           AS INTEGER     NO-UNDO.

  DEFINE BUFFER Brtb_ver    FOR rtb.rtb_ver.
  DEFINE BUFFER Brtb_wspmod FOR rtb.rtb_wspmod.

  IF PshowWsUsage THEN
    FOR EACH Brtb_wspmod NO-LOCK
      WHERE  Brtb_wspmod.pmod = Ppmod
      WITH FRAME source-frame:

      DISPLAY STREAM Sout
        " "
        Brtb_wspmod.wspace-id 
        Brtb_wspmod.src-wspace-id
        Brtb_wspmod.src-status
        WITH FRAME source-frame STREAM-IO.
    END.

  HIDE STREAM Sout FRAME source-frame NO-PAUSE.

  IF PshowObjects THEN
  FOR EACH Brtb_ver
    WHERE Brtb_ver.pmod   = Ppmod NO-LOCK
    BREAK BY Brtb_ver.obj-type 
          BY Brtb_ver.object:

    IF FIRST-OF(Brtb_ver.obj-type) THEN
      PUT STREAM Sout
        SKIP(1)
        "  " TRIM(CAPS(Brtb_ver.obj-type)) SKIP.

    IF FIRST-OF(Brtb_ver.object) THEN DO:

      RUN rtb_get_object_version_details
        (INPUT  Brtb_ver.pmod,
         INPUT  Brtb_ver.obj-type,
         INPUT  Brtb_ver.object,
         INPUT  Brtb_ver.version,
         OUTPUT Mdescription,
         OUTPUT MtextLines).

      PUT STREAM Sout
        "   " + Brtb_ver.object + " / " + Mdescription FORMAT "x(120)" SKIP.

      IF PshowObjDetails THEN DO Mi = 1 TO 9:
        Mline = SUBSTRING(Mtextlines,(Mi - 1) * 76 + 1, 76).
        IF TRIM(Mline) <> "" THEN
          PUT STREAM Sout "   " Mline FORMAT "x(76)" SKIP.
      END.

      IF PshowObjDetails THEN PUT STREAM Sout SKIP(1).

    END. /* first-of */
  END. /* each brtb_ver */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_product_module_report) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_product_module_report Procedure 
PROCEDURE rtb_product_module_report :
/*------------------------------------------------------------------------------
  Purpose:     Product module report
  Parameters:  INPUT Ppmod             - Product module
               INPUT PshowWsUsage      - TRUE to show workspace usage
               INPUT PshowObjects      - TRUE to show objects
               INPUT PshowObjDetails   - TRUE to show object details
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Ppmod            AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PshowWsUsage     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjects     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjDetails  AS LOGICAL     NO-UNDO.
  
  DEFINE BUFFER Brtb_pmod    FOR rtb.rtb_pmod.
  DEFINE BUFFER Brtb_product FOR rtb.rtb_product.

  report-block:
  DO:
    FIND Brtb_pmod WHERE Brtb_pmod.pmod = Ppmod NO-LOCK NO-ERROR.
    IF NOT AVAILABLE Brtb_pmod THEN LEAVE report-block.

    FIND Brtb_product OF Brtb_pmod NO-LOCK NO-ERROR.
    IF NOT AVAILABLE Brtb_product THEN LEAVE report-block.
    
    {rtb/i/rtb_rpthdr.i
      &title="""Product Module Report"""
      &criteria="""Product:"" Brtb_product.product-id FORMAT ""x(50)"" SKIP
                 ""   Name:"" Brtb_product.product-name                SKIP
                 ""Pmodule:"" Brtb_pmod.pmod          FORMAT ""x(80)"" SKIP
                 ""   Desc:"" Brtb_pmod.DESCRIPTION                    SKIP(1)"
      &center-criteria=NO
      &STREAM=Sout}

    PUT STREAM Sout
      "  Workspace Module: " Brtb_pmod.module FORMAT "X(80)" SKIP.

    RUN rtb_print_pmod (Ppmod, PshowWsUsage, PshowObjects, PshowObjDetails).
    
    {rtb/i/rtb_rptftr.i &STREAM=Sout}
  
  END. /* report block */
  
END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_product_report) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_product_report Procedure 
PROCEDURE rtb_product_report :
/*------------------------------------------------------------------------------
  Purpose:     Product report
  Parameters:  INPUT Pproduct          - Product
               INPUT PshowWsUsage      - TRUE to show workspace usage
               INPUT PshowObjects      - TRUE to show objects
               INPUT PshowObjDetails   - TRUE to show object details
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Pproduct         AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PshowWsUsage     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjects     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjDetails  AS LOGICAL     NO-UNDO.

  DEFINE BUFFER Brtb_pmod    FOR rtb.rtb_pmod.
  DEFINE BUFFER Brtb_product FOR rtb.rtb_product.

  FIND Brtb_product WHERE Brtb_product.product-id = Pproduct NO-LOCK NO-ERROR.

  IF AVAILABLE Brtb_product THEN DO:
    
    FOR EACH Brtb_pmod OF Brtb_product NO-LOCK 
      ON ERROR UNDO, LEAVE:
  
      {rtb/i/rtb_rpthdr.i 
        &title="""Product Report"""
        &criteria="""Product:"" Brtb_product.product-id FORMAT ""x(50)"" SKIP
                   ""   Name:"" Brtb_product.product-name"
        &center-criteria=NO
        &STREAM=Sout}
  
      IF PAGE-NUMBER <> 1 THEN 
        PUT STREAM Sout SKIP(1).
      
      PUT STREAM Sout
        FILL("-",120)                              FORMAT "X(120)" SKIP
        "  Product Module: " Brtb_pmod.pmod        FORMAT "X(80)"  SKIP
        "     Description: " Brtb_pmod.description FORMAT "X(80)"  SKIP
        "Workspace Module: " Brtb_pmod.module      FORMAT "X(80)"  SKIP.
  
      RUN rtb_print_pmod (Brtb_pmod.pmod, PshowWsUsage, PshowObjects, PshowObjDetails).
                          
    END. /* of EACH Brtb_pmod */
    
    {rtb/i/rtb_rptftr.i &STREAM=Sout}

  END. /* available brtb_product */

  RETURN.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

&IF DEFINED(EXCLUDE-rtb_versions_in_product_module_report) = 0 &THEN

&ANALYZE-SUSPEND _UIB-CODE-BLOCK _PROCEDURE rtb_versions_in_product_module_report Procedure 
PROCEDURE rtb_versions_in_product_module_report :
/*------------------------------------------------------------------------------
  Purpose:     Versions in product module report
  Parameters:  INPUT Ppmod         - Product module for object
                     Pobj-type     - Object-type for object
                     Pobject       - Object name
                     PbegVersion   - Starting version
                     PendVersion   - Ending version
                     PmaxVersions  - Maximum number of versions to show
                     PshowOrphans  - TRUE to show orphans
                     PshowObjDesc  - TRUE to show object descriptions
                     PshowVerNotes - TRUE to show version notes
  Notes:       
------------------------------------------------------------------------------*/
  DEFINE INPUT PARAMETER Ppmod            AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pobj-type        AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER Pobject          AS CHARACTER   NO-UNDO.
  DEFINE INPUT PARAMETER PbegVersion      AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PendVersion      AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PmaxVersions     AS INTEGER     NO-UNDO.
  DEFINE INPUT PARAMETER PshowOrphans     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowObjDesc     AS LOGICAL     NO-UNDO.
  DEFINE INPUT PARAMETER PshowVerNotes    AS LOGICAL     NO-UNDO.
  
  DEFINE VARIABLE Mdescription     AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Merror           AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mline-out        AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mold-description AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mold-textlines   AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE MtextLines       AS CHARACTER   NO-UNDO.
  DEFINE VARIABLE Mi               AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mprev-version    AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Mversion-count   AS INTEGER     NO-UNDO.
  DEFINE VARIABLE Morphan          AS LOGICAL     NO-UNDO.
  DEFINE VARIABLE Mskip-record     AS LOGICAL     NO-UNDO.

  DEFINE BUFFER Brtb_ver FOR rtb.rtb_ver.

  rpt-block:
  DO:
    /*
     Validate input parameters...
    */
    /*
     Ppmod
    */
    IF NOT CAN-FIND(rtb.rtb_pmod WHERE rtb.rtb_pmod.pmod = Ppmod) THEN DO:
      Merror = SUBSTITUTE("Product Module '&1' does not exist.",Ppmod).
      LEAVE rpt-block.
    END.
    /*
     Pobj-type
    */
    IF LOOKUP(Pobj-type,"DOC,PCODE,PDBASE,PFILE,PFIELD") = 0 THEN DO:
      Merror = SUBSTITUTE("Invalid object type '&1'.",Pobj-type).
      LEAVE rpt-block.
    END.
    /*
     Pobject
    */
    FIND FIRST Brtb_ver WHERE Brtb_ver.pmod     = Ppmod
                          AND Brtb_ver.obj-type = Pobj-type
                          AND Brtb_ver.object   = Pobject NO-LOCK NO-ERROR.
    IF NOT AVAILABLE Brtb_ver THEN DO:
      Merror = SUBSTITUTE("Object '&1' not found.",Pobject).
      LEAVE rpt-block.
    END.
    /*
     Versions
    */
    FIND FIRST Brtb_ver WHERE Brtb_ver.pmod     = Ppmod
                          AND Brtb_ver.obj-type = Pobj-type
                          AND Brtb_ver.object   = Pobject
                          AND Brtb_ver.version <= PbegVersion NO-LOCK NO-ERROR.
    IF NOT AVAILABLE Brtb_ver THEN DO:
      Merror = SUBSTITUTE("No version of '&1' was found prior to Version &2.",
                          Pobject,PbegVersion).
      LEAVE rpt-block.
    END.

    /*
     Produce report
    */    
    ASSIGN Mprev-version  = Brtb_ver.prev-version
           Mversion-count = 1. 

    DO WHILE AVAILABLE Brtb_ver 
      ON ENDKEY UNDO, LEAVE
      ON ERROR UNDO, LEAVE 
      WITH FRAME object-frame STREAM-IO:

      {rtb/i/rtb_rpthdr.i 
          &title="""Versions in Product Module Report"""
          &criteria="""         Type:"" Pobj-type                      SKIP
                     ""       Object:"" Pobject       FORMAT ""X(58)"" SKIP
                     "" Max Versions:"" PmaxVersions FORMAT "">>>9""  SKIP
                     ""Show Orphans?:""        IF PshowOrphans  THEN YES ELSE NO
                     "" Show Descriptions?:""  IF PshowObjDesc  THEN YES ELSE NO
                     "" Show Version Notes?:"" IF PshowVerNotes THEN YES ELSE NO
                     SKIP(1)"
          &center-criteria=NO
          &STREAM=Sout}

      /*
       Get object version detail
      */
      RUN rtb_get_object_version_details (INPUT  Brtb_ver.pmod,
                                          INPUT  Brtb_ver.obj-type,
                                          INPUT  Brtb_ver.object,
                                          INPUT  Brtb_ver.version,
                                          OUTPUT Mdescription,
                                          OUTPUT MtextLines).
      /*
       Is this an orphaned version?
      */
      IF PshowOrphans AND
         CAN-FIND(rtb.rtb_ver
                  WHERE rtb.rtb_ver.pmod     = Brtb_ver.pmod
                    AND rtb.rtb_ver.object   = Brtb_ver.object
                    AND rtb.rtb_ver.obj-type = Brtb_ver.obj-type
                    AND (rtb.rtb_ver.version GT Brtb_ver.version
                         AND rtb.rtb_ver.prev-version LT Brtb_ver.version)) THEN
        ASSIGN Morphan = YES.
      ELSE
        ASSIGN Morphan = NO
               Mprev-version = Brtb_ver.prev-version.
     
      /*
       If this version is an orphan but hide-orphan is set to true, then
       skip the record and go fetch the next one.
      */
      ASSIGN Mskip-record = (Morphan AND Brtb_ver.hide-orphan).
         
      IF NOT Mskip-record THEN DO:
        IF Morphan THEN 
          PUT STREAM Sout "*** Following version orphaned *****" SKIP.

        IF PshowObjDesc AND (Mold-description <> Mdescription) THEN DO:      
          PUT STREAM Sout
            "Description: " SUBSTRING(Mdescription, 1, 40) FORMAT "x(40)" SKIP.
          IF SUBSTRING(Mdescription, 41, 76) <> "" THEN
            PUT STREAM Sout
              "             " SUBSTRING(Mdescription, 41, 76) FORMAT "x(36)" SKIP.
          ASSIGN Mold-description = Mdescription.
        END.  /* if PshowObjDesc and mold-description... */

        IF Mold-textlines <> MtextLines THEN DO:
          IF Mold-textlines <> MtextLines THEN DO Mi = 1 TO 9:
            ASSIGN Mline-out = SUBSTRING(MtextLines,(Mi - 1) * 76 + 1, 76).
            IF TRIM(Mline-out) <> "" THEN
              PUT STREAM Sout Mline-out FORMAT "x(76)" SKIP.
          END.  /* if moldl-textlines <> MtextLines */

          ASSIGN Mold-textlines = MtextLines.
        END.  /* if PshowObjDesc and mold-textlines... */

        PUT STREAM Sout SKIP.

        IF PshowVerNotes THEN DO:
          PUT STREAM Sout "Note:". 
          
          Mline-out = DYNAMIC-FUNCTION('fnRtbBreakLines':U,Brtb_ver.upd-notes,60).
          DO WHILE Mline-out <> ?:
            PUT STREAM Sout UNFORMATTED Mline-out AT 7 SKIP.
            Mline-out = DYNAMIC-FUNCTION('fnRtbBreakLines':U,?,60).
          END.  /* do while mline-out <> "" */  
          
          PUT STREAM Sout SKIP(1).
        END. /* pshowvernores */
      END. /* not skip record */
      
      IF Brtb_ver.version = Brtb_ver.prev-version OR
         Brtb_ver.version <= PendVersion THEN LEAVE. 

      /*
       If display orphans is turnt (for Gerry) on, then find the actual next
       sequential version record.  Otherwise, get the next record based on 
       previous version.
      */
      IF PshowOrphans THEN 
        FIND NEXT Brtb_ver
          WHERE Brtb_ver.pmod     = Ppmod
            AND Brtb_ver.obj-type = Pobj-type
            AND Brtb_ver.object   = Pobject  NO-LOCK NO-ERROR.
      ELSE 
        FIND Brtb_ver
          WHERE Brtb_ver.pmod     = Ppmod
            AND Brtb_ver.obj-type = Pobj-type
            AND Brtb_ver.object   = Pobject
            AND Brtb_ver.version  = Mprev-version NO-LOCK NO-ERROR.

      IF NOT AVAILABLE Brtb_ver THEN LEAVE.

      ASSIGN Mversion-count = Mversion-count + 1.

      IF  Mversion-count > PmaxVersions THEN LEAVE.
  
    END. /* do while avail... */
  
    {rtb/i/rtb_rptftr.i &STREAM=Sout}

  END.  /* rpt-block */

  RETURN Merror.

END PROCEDURE.

/* _UIB-CODE-BLOCK-END */
&ANALYZE-RESUME

&ENDIF

